package no.ntnu.idatt1002.demo.data.Budget;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class FileHandlingSelectedBudget {

  private static final String filePath = "src/main/resources/budgets/";

  private static final String selectedBudgetFileType = ".current";
  private static final String registerFileType = ".register";
  private static final String budgetFileType = ".budget";

  private static final String slash = "/";

  public static String readSelectedBudget() throws IOException {
    try (BufferedReader br = new BufferedReader(new FileReader(filePath + "SelectedBudget" +
        selectedBudgetFileType))) {
      return br.readLine();
    } catch (IOException ioException) {
      throw new IOException("File: SelectedBudget.current does not exist", ioException);
    }
  }

  public static void updateSelectedBudget(String budgetName) throws IOException {
    try (BufferedWriter bw = new BufferedWriter(new FileWriter(filePath + "SelectedBudget" +
        selectedBudgetFileType))) {
      bw.write(budgetName);
      System.out.println("Current file is: " + budgetName);
    } catch (IOException ex) {
      throw new IOException("Error writing to file: " + "SelectedBudget.current");
    }
  }

  public static void clearSelectedBudget() throws IOException {
    try (BufferedWriter bw = new BufferedWriter(new FileWriter(filePath + "SelectedBudget" +
        selectedBudgetFileType))) {
      bw.write("");
      System.out.println("Current file is: ");
    } catch (IOException ex) {
      throw new IOException("Error writing to file: " + "SelectedBudget.current");
    }
  }

  public static boolean isSelectedBudgetEmpty(String fileTitle) throws IOException {
    try (BufferedReader br = new BufferedReader(new FileReader(filePath
        + "SelectedBudget" + selectedBudgetFileType))) {
      return br.readLine() == null;
    }
  }
  
  public static boolean createBudgetDirectory(String budgetId) {
    System.out.println("Directory: " + filePath + budgetId);
    File f = new File(filePath + budgetId);
    return f.mkdir();
  }
  
  public static void createNewIncomeFile(String budgetId, String incomeFileTitle) throws IOException {
    System.out.println("Income filepath: " + filePath + budgetId + "/" + incomeFileTitle + registerFileType);
    File incomeFile = new File(filePath +  budgetId + "/" + incomeFileTitle + registerFileType);
    incomeFile.createNewFile();
  }

  public static void createNewExpenseFile(String budgetId, String expenseFileTitle) throws IOException {
    System.out.println("Expense filePath: " + filePath + budgetId + "/" + expenseFileTitle + registerFileType);
    File expenseFile = new File(filePath + budgetId + "/" + expenseFileTitle + registerFileType);
    expenseFile.createNewFile();
  }

  public static void createNewBudgetFile(String budgetId, String budgetFileTitle) throws IOException {
    System.out.println("Budget filePath: " + filePath + budgetId + "/" + budgetFileTitle + budgetFileType);
    File budgetFile = new File(filePath + budgetId + "/" + budgetFileTitle + budgetFileType);
    budgetFile.createNewFile();
  }
}
